=== debian/changelog ===
libubox (17.01+2~f2d6752-2+6genuen1) unstable; urgency=medium

  * Build for excalibur

 -- Aitor <aitor@genuen.org>  Sun, 25 Jan 2026 19:45:41 +0100

libubox (17.01+2~f2d6752-2+5gnuinos1) unstable; urgency=medium

  * Build for daedalus

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Thu, 18 May 2023 23:51:29 +0200

libubox (17.01+2~f2d6752-2+4gnuinos1) unstable; urgency=medium

  * Replace CMake build system with GNU Make.

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Fri, 09 Dec 2022 22:00:18 +0100

libubox (17.01+1~f2d6752-2) chimaera; urgency=medium

  * Build without lua

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Sat, 26 Mar 2022 22:26:05 +0100

libubox (17.01+1~f2d6752-1) chimaera; urgency=medium

  * New upstream 2022-02-10 f2d6752901f2f2d8612fb43e10061570c9198af1
    - https://git.openwrt.org/project/libubox.git

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Sun, 13 Mar 2022 21:39:30 +0100

libubox (0.1-1) beowulf; urgency=medium

  * Changed source format to quilt.
  * Imported into gnuinos beowulf.

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Wed, 09 Dec 2020 20:30:08 +0100

libubox (0.1) UNRELEASED; urgency=medium

  * Initial release.

 -- Alexander Couzens <lynxis@fe80.eu>  Tue, 23 Apr 2019 13:54:51 +0000
