=== debian/control ===
Source: libubox
Section: admin
Priority: optional
Maintainer: Aitor Cuadrado Zubizarreta <aitor@genuen.org>
Uploaders: Alexander Couzens <lynxis@fe80.eu>, Sergey Ponomarev <stokito@gmail.com>
Build-Depends: debhelper (>= 12), fakeroot, libc6-dev (>= 2.31-13~), pkg-config, libjson-c-dev (>= 0.15-2)
Standards-Version: 4.5.1
Origin: Genuen
Vcs-Browser: https://git.genuen.org/genuen/libubox
Vcs-Git: https://git.genuen.org/genuen/libubox.git

Package: libubox1
Architecture: linux-any
Section: libs
Multi-Arch: same
Conflicts: libubox0
Replaces: libubox0
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libjson-c5 (>= 0.15-2)
Description: OpenWrt core utilities - library (runtime)
 A library used by many OpenWrt projects.
 It's one of the core libraries used within openwrt because
 it's a set of utilities, mostly wrappers, that are present
 usually in programs and that have been coded in a flexible
 and reusable way to avoid wasting time.

Package: libubox-dev
Architecture: linux-any
Section: libdevel
Multi-Arch: same
Depends: libubox1 (= ${binary:Version}),
        ${shlibs:Depends}, ${misc:Depends}
Description: OpenWrt core utilities - library (development files)
 A library used by many OpenWrt projects.
 It's one of the core libraries used within openwrt because
 it's a set of utilities, mostly wrappers, that are present
 usually in programs and that have been coded in a flexible
 and reusable way to avoid wasting time.
